let baseURL
let userInfo
let salt = 'horace-allin'

$(function () {
  baseURL =
    location.href.indexOf('dt.freetelcall.com') > -1 || location.href.indexOf('dtknife.tzwebsitetest.com') > -1
      ? baseInfo.prod_server
      : baseInfo.dev_server

  console.log('baseURL', baseURL)

  if (location.href.indexOf('isDevelop') > -1) {
    userInfo = {
      appName: 'Talku',
      c: 'CN',
      d: 1,
      deviceId: 'And.71a981648739f0e1f422fcf053dfad45.dttalk',
      dtId: '71137108',
      i: 'aa4Yho',
      lang: 'en',
      loginIp: '122.225.226.202',
      loginisoCC: 'CN',
      nickName: 'aggbv',
      osType: 'Android',
      pid: 3,
      token: '86315f66c31b70840717df67daee8ef4',
      type: '100',
      uid: '71116438934363513',
      userId: '7111643893455955',
      version: '4.16.3',
      appId: 67,
    }
    localStorage.setItem('clientUserInfo', JSON.stringify(userInfo))
  } else {
    if (localStorage.getItem('clientUserInfo')) {
      userInfo = JSON.parse(localStorage.getItem('clientUserInfo'))
    }
  }
})

//首页初始化
function homePageInit () {
  return new Promise((resolve, reject) => {
    let { userId, pid, deviceId } = userInfo
    $.get(
      `${baseURL}/knife/homePage`,
      {
        userId,
        appType: pid,
        deviceId,
        timeStamp: new Date().getTime(),
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//看广告已获取的游戏次数
function searchVideoChance () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/watchingGetPlayTimes`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//push通知开关
function switchLocalPush (noticeSwitch) {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/switchNotice`,
      {
        userId: userId,
        appType: pid,
        noticeSwitch,
        timeStamp: new Date().getTime(),
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//打开宝箱
function openTreasure () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/openTreasureBox`,
      {
        userId: userId,
        appType: pid,
        timeStamp: new Date().getTime(),
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//游戏页面初始化
function gamePageInit () {
  return new Promise((resolve, reject) => {
    console.log('userInfo11111', userInfo, baseURL)
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/play`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//转盘奖励初始化
function turntableInit (level) {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    let timeStamp = new Date().getTime()
    let md5Param = MD5(`${Number(userId)}-${Number(pid)}-${Number(level)}-${Number(timeStamp)}-${salt}`)
    $.get(
      `${baseURL}/knife/lotteryPage`,
      {
        userId: userId,
        appType: pid,
        level,
        md5: md5Param,
        timeStamp: timeStamp,
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//转盘抽奖
function lottery (lotteryId) {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    let timeStamp = new Date().getTime()
    let md5Param = MD5(
      `${userId}-${pid}-${lotteryId}-${timeStamp}-${salt}`
    )
    $.get(
      `${baseURL}/knife/lottery`,
      {
        userId,
        appType: pid,
        lotteryId,
        md5: md5Param,
        timeStamp,
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//奖励翻倍
function prizeDouble (prizeType, totalPrizeCount) {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/doublePrize`,
      {
        userId: userId,
        appType: pid,
        prizeType,
        totalPrizeCount,
        timeStamp: new Date().getTime(),
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//查询复活机会
function searchRetryChance () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/reviveInfo`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//复活
function gameRetry () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/revive`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//看广告加机会
function addChance () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/watchingForPlay`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//武器页面初始化
function armsPageInit () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/weapon/homePage`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//看广告抽武器
function getArmByVideo () {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/weapon/lottery`,
      { userId: userId, appType: pid, timeStamp: new Date().getTime() },
      (res) => {
        resolve(res)
      }
    )
  })
}

//兑换武器
function armsCovert (weaponId) {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/weapon/buy`,
      {
        userId: userId,
        appType: pid,
        weaponId,
        timeStamp: new Date().getTime(),
      },
      (res) => {
        resolve(res)
      }
    )
  })
}

//使用武器
function armUse (weaponId) {
  return new Promise((resolve, reject) => {
    let { userId, pid } = userInfo
    $.get(
      `${baseURL}/knife/weapon/use`,
      {
        userId: userId,
        appType: pid,
        weaponId,
        timeStamp: new Date().getTime(),
      },
      (res) => {
        resolve(res)
      }
    )
  })
}
