let armsInfo
let selectArmInfo
let activityInfo

$(function () {
  //看广告抽武器
  if (localStorage.getItem('KnifeArmsInfo')) {
    armsInfo = JSON.parse(localStorage.getItem('KnifeArmsInfo'))
  }

  if (localStorage.getItem('knifeGameActivityInfo')) {
    activityInfo = JSON.parse(localStorage.getItem('knifeGameActivityInfo'))
  }

  adPreWatch(5401, baseInfo.campaignId, baseInfo.adIdArms)
  armsPageInitReday()
})

function armsPageInitReday() {
  armsPageInit().then((res) => {
    //保证userInfo已经获取成功
    navBackClicked(5601, 0, userInfo.pid, userInfo.version)

    if (res.Result === 1 && res.data) {
      armsInfo = res.data
      localStorage.setItem('KnifeArmsInfo', JSON.stringify(armsInfo))
      armsInfoHandle()
      console.log('获取武器列表成功', res)

    } else {
      console.log('获取武器列表失败', res)
    }
  })
    .catch((err) => {
      console.error('获取武器列表失败', err)
    })
}

function armsInfoHandle() {
  //果汁数
  $('.fruit-number').text(armsInfo.fruitJuiceAmount)
  $('.current-arms').css(
    'backgroundImage',
    `url('./img/arms-item${armsInfo.weaponIdInUse}.png')`
  )
  $('.fruit-icon').css('display', 'none')
  $('.purcase-fruit-number').text('In Use')
  userSelectArmInfo = armsInfo.weaponList[armsInfo.weaponIdInUse]

  //当日已领取次数不等于可领取次数时，按钮显示呼吸效果
  addBreath(
    armsInfo.watchingGetWeaponTimes < armsInfo.watchingGetWeaponTimesLimit,
    '.video-area'
  )

  //有飞刀均已永久获得，按钮不再显示
  if (armsInfo.weaponList.every((item) => item['type'] === 1)) {
    $('.video-area').css('display', 'none')
  }

  var str = ''
  $.each(armsInfo.weaponList, (index, item) => {
    //未拥有
    if (!item['type']) {
      str =
        str +
        `<li class="unopend-item" data="${index}">
    <img src="./img/arms-item${index}-small.png" />
    <div class="unopened-price-tag">${item['cost']}</div>
  </li>`
    } else if (item['type'] === 1) {
      //永久拥有
      str =
        str +
        `<li class="opened-item" data="${index}">
      <img src="./img/arms-item${index}-small.png"/>
    </li>`
    } else if (item['type'] === 2) {
      //临时拥有,今日获新
      if (item['newReceive']) {
        str =
          str +
          `<li class="opened-item" data="${index}">
    <img src="./img/arms-item${index}-small.png" />
    <div class="new-tag">NEW!</div>
  </li>`
      } else {
        //今日未获新
        str =
          str +
          `<li class="opened-item" data="${index}">
    <img src="./img/arms-item${index}-small.png" />
    <div class="left-day">${item['daysRemaining']} day left</div>
  </li>`
      }
    }
  })

  $('.knife-list').append(str)
  $(`.knife-list li:eq(${armsInfo.weaponIdInUse})`).addClass('selected-item')

  $('.knife-list li:eq(3)').addClass('nomarright')
  $('.knife-list li:eq(7)').addClass('nomarright')

  $('.knife-list').append(`<li class="unopend-item nomarbottom">
  <img class="waiting-icon" src="./img/waiting.png" />
  </li>`)
}

//添加呼吸效果
function addBreath(breathStatus, ele) {
  if (breathStatus) {
    $(ele).addClass('breath')
  } else {
    $(ele).removeClass('breath')
    $(ele).addClass('gray')
  }
}

//arms.html: show ads for get weapon
var watchVideoing = false
$('.video-area').click(() => {
  //arms.html: in watching videos
  if (watchVideoing) {
    return
  }
  watchVideoing = !watchVideoing
  if (armsInfo.watchingGetWeaponTimes >= armsInfo.watchingGetWeaponTimesLimit) {
    console.log('arms.html: more than max times')
    Toast.init()
    Toast.show(
      `You've reached the limit today`,
      3000
    )
    setTimeout(function () {
      Toast.hide()
    }, 3000)
    watchVideoing = false
    return
  }

  //arms.html: show ads
  adPreWatch(5400, baseInfo.campaignId, baseInfo.adIdArms)
  setTimeout(() => {
    adPreWatch(5401, baseInfo.campaignId, baseInfo.adIdArms)
  }, 5000)

  ga('send', 'event', 'dingtone_knife_game', 'WatchAdsSuccess', `ad=${baseInfo.adIdArms}`, 1);

  getArmByVideo().then((res) => {
    if (res.Result === 1 && res.data) {
      ga('send', 'event', 'dingtone_knife_game', 'WatchAdsforKnife', 'WatchAdsforKnife', 1);
      watchVideoing = false
      selectArmInfo = res.data

      //改变已加广告机会
      armsInfo.watchingGetWeaponTimes = armsInfo.watchingGetWeaponTimes + 1
      addBreath(
        armsInfo.watchingGetWeaponTimes < armsInfo.watchingGetWeaponTimesLimit,
        '.video-area'
      )
      $('.modal').css('display', 'block')

      // var popHieght = $('.hor-ver-center-center').height()
      //抽中武器弹窗
       $('.knife-selected-content-info').css('display', 'block')
       $('.modal-knife-prize').css(
         'backgroundImage',
         `url('./img/arms-item${selectArmInfo.weaponId}-small.png')`
       )
      
      console.log(parseInt(document.querySelector('html').getAttribute('data-dpr')))
      console.log($('.modal .modal-content-info').filter(function (item) { return $(this).css('display') === 'block' })[0].offsetWidth)
      console.log($('.modal .modal-content-info').filter(function (item) { return $(this).css('display') === 'block' })[0].offsetHeight)
      console.log($('.modal .modal-content-info').filter(function (item) { return $(this).css('display') === 'block' })[0].className)
      console.log($('.modal .modal-content-info').filter(function (item) { return $(this).css('display') === 'block' })[0])
      var popHieght = $('.modal .modal-content-info').filter(function (item) { return $(this).css('display') === 'block' })[0].offsetHeight
      var dpr = parseInt(document.querySelector('html').getAttribute('data-dpr'))
      //抽武器机会弹窗
      bannerAdHandle(
        userInfo.pid,
        userInfo.version,
        baseInfo.campaignId,
        baseInfo.adIdKnifeCollect,
        popHieght
      ).then((res) => {
        if (!res) {
          $('.hor-ver-center-center').css('top', 0)
        } else {
          let topHeight = res + 'px'
          $('.hor-ver-center-center').css('top', topHeight).css('bottom', 'auto')
          // reset location
          setTimeout(()=>{
            $('.hor-ver-center-center').css('top', 0)
          }, 2000)
        }
      })
      let index = armsInfo.weaponList.findIndex((item) => item['weaponId'] === selectArmInfo.weaponId)
      armsInfo.weaponList.splice(index, 1, selectArmInfo)

      console.log('armsInfo.weaponList', armsInfo.weaponList)

      //武器列表动态变化
      if (selectArmInfo.type === 2) {
        $('.modal-info-tips').css('display', 'block')
      } else {
        $('.modal-info-tips').css('display', 'none')
      }
      $(`.knife-list li:eq(${selectArmInfo.weaponId})`)
        .removeClass('unopend-item')
        .addClass('opened-item')
      $(`.knife-list li:eq(${selectArmInfo.weaponId}) .unopened-price-tag`).css('display', 'none')
      $(`.knife-list li:eq(${selectArmInfo.weaponId})`).append(
        '<div class="new-tag">NEW!</div>'
      )

      //兑换按钮变化
      $('.fruit-icon').css('display', 'none')
      $('.purcase-fruit-number').text('Use')

      console.log('看广告武器成功')
    } else {
      watchVideoing = false
    }
  })
    .catch((err) => {
      watchVideoing = false
      console.error('看广告抽武器失败', err)
    })
})

let selectIndex
let userSelectArmInfo
//选择武器
$('.knife-list').on('touchstart', 'li', function () {
  selectIndex = $(this).attr('data')
  $(`.knife-list li:eq(${selectIndex})`)
    .addClass('selected-item')
    .siblings()
    .removeClass('selected-item')

  //选中使用的武器
  $('.current-arms').css(
    'backgroundImage',
    `url('./img/arms-item${selectIndex}.png')`
  )
  userSelectArmInfo = armsInfo.weaponList[Number(selectIndex)]
  console.log(
    'Number(selectIndex) === userSelectArmInfo.weaponIdInUse',
    userSelectArmInfo,
  )
  if (!userSelectArmInfo.type) {
    //如选中武器为未解锁飞刀，图片右侧显示‘Redeem’按钮及所需果篮数，点击兑换按钮，兑换成功后弹窗提示
    $('.fruit-icon').css('display', 'block')
    $('.purcase-fruit-number').text(userSelectArmInfo.cost)
  } else if (
    (userSelectArmInfo.type === 1 || userSelectArmInfo.type === 2) &&
    Number(selectIndex) === armsInfo.weaponIdInUse
  ) {
    //如选中武器为使用中飞刀，图片右侧显示状态提示文案'In Use'
    $('.fruit-icon').css('display', 'none')
    $('.purcase-fruit-number').text('In Use')
  } else {
    //如选中武器为已获得未使用的飞刀，图片右侧显示按钮‘Use’，点击按钮，更换成功显示状态变为‘使用中’
    $('.fruit-icon').css('display', 'none')
    $('.purcase-fruit-number').text('Use')
  }
})

//选择武器使用
var purcasing = false
$(document).on('click', '.purcase-bgn', () => {
  console.log('韩哈哈')

  if (purcasing) {
    return
  }
  purcasing = !purcasing
  console.log('userSelectArmInfo==', userSelectArmInfo)
  if (!userSelectArmInfo.type) {
    //兑换武器
    //果汁不足
    if (userSelectArmInfo.cost > armsInfo.fruitJuiceAmount) {
      purcasing = false
      Toast.init()
      Toast.show(
        `You need more fruit juice`,
        3000
      )
      setTimeout(function () {
        Toast.hide()
      }, 3000)
      return
    }

    console.log('兑换武器')
    armsCovert(Number(selectIndex)).then((res) => {
      if (res.Result === 1 && res.data) {
        ga('send', 'event', 'dingtone_knife_game', 'RedeemKnife', 'RedeemKnife', 1);
        armsInfo.weaponIdInUse = Number(selectIndex)
        $(`.knife-list li:eq(${armsInfo.weaponIdInUse}`)
          .addClass('opened-item')
        $(`.knife-list li:eq(${armsInfo.weaponIdInUse}) .unopened-price-tag`).css('display', 'none')
        $('.purcase-fruit-number').text('In Use')
        $('.fruit-icon').css('display', 'none')
        purcasing = false
      } else {
        purcasing = false
      }
    })
      .catch((err) => {
        purcasing = false
        console.error('使用武器失败', err)
      })
  } else if (
    (userSelectArmInfo.type === 1 || userSelectArmInfo.type === 2) &&
    Number(selectIndex) !== armsInfo.weaponIdInUse
  ) {
    //使用武器
    console.log('使用武器')
    armUse(selectIndex).then((res) => {
      if (res.Result === 1 && res.data) {
        ga('send', 'event', 'dingtone_knife_game', 'knife_game_use_arm', 'knife_game_use_arm_btn', 1);
        armsInfo.weaponIdInUse = Number(selectIndex)
        $('.purcase-fruit-number').text('In Use')
        $(`.knife-list li:eq(${selectIndex})`)
          .addClass('selected-item')
          .siblings()
          .removeClass('selected-item')
        purcasing = false
      } else {
        purcasing = false
      }
    })
      .catch((err) => {
        purcasing = false
        console.error('使用武器失败', err)
      })
  } else {
    purcasing = false
  }
})

//关闭弹窗
$(document).on('click', '.modal-close-icon', () => {
  $('.modal').css('display', 'none')
  $('.knife-selected-content-info').css('display', 'none')
  // if(window.screen.height<640){
  //   adNativeShow(5402, 0, baseInfo.campaignId,baseInfo.adIdKnifeCollect, userInfo.pid,userInfo.version)
  // }else{
  //   hide5405Ad(baseInfo.adIdKnifeCollect, baseInfo.campaignId)
  // }
  bannerAdHide(
    userInfo.pid,
    userInfo.version,
    baseInfo.campaignId,
    baseInfo.adIdKnifeCollect,
    650
  )
})

//开始按钮
$(document).on('click', '.start-btn', () => {
  if (!activityInfo.remainPlayTimes) {
    Toast.init()
    Toast.show(`Chances used out`, 3000)
    setTimeout(function () {
      Toast.hide()
    }, 3000)
    return
  }

  $('.modal').css('display', 'none')
  $('.knife-selected-content-info').css('display', 'none')
  window.location.href = './play.html' + window.location.search
  // if (window.screen.height < 640) {
  //   adNativeShow(5402, 0, baseInfo.campaignId, baseInfo.adIdKnifeCollect, userInfo.pid, userInfo.version)
  // } else {
  //   hide5405Ad(baseInfo.adIdKnifeCollect, baseInfo.campaignId)
  // }
  bannerAdHide(
    userInfo.pid,
    userInfo.version,
    baseInfo.campaignId,
    baseInfo.adIdKnifeCollect,
    650
  )
})
