/*方法说明
 *@method 跑马灯
 *@for 所属类名
 *@param{
  wrapperId  容器的id
  listId     列表的id
  speed      跑马灯速度
 }
 *@return {}
*/
function marquee (wrapperId, listId, speed) {
  //容器的宽度
  var scrollWidth = $(wrapperId).width();

  //列表实际宽度
  var textWidth = $(listId).width();
  var i = scrollWidth;

  setInterval(function () {
    i = i - speed;
    if (i < -textWidth) {
      i = scrollWidth;
    }
    $(listId).animate({
      'left': i + 'px'
    }, 70);
  }, 70);
}

/*方法说明
 *@method 时间戳格式化
 *@for 所属类名
 *@param{
  endTime    时间戳
  type       1-毫秒;2-秒
 }
 *@return {
  timeObj    格式转化后的字符串
 }
*/
function countdown (endTime, type) {
  var currTime = new Date().getTime()
  var diffTime
  if (type === 1) {
    diffTime = (endTime - currTime) / 1000
  } else {
    diffTime = endTime
  }

  var timeObj
  if (diffTime >= 0) {
    var day = Math.floor(diffTime / 3600 / 24)
    var h = Math.floor((diffTime / 3600) % 24).toString()
    var m = Math.floor((diffTime / 60) % 60).toString()
    var s = Math.floor(diffTime % 60).toString()
    timeObj = {
      day: day,
      hour: add0(h),
      minute: add0(m),
      secoend: add0(s)
    }
  } else {
    timeObj = {
      day: 0,
      hour: '00',
      minute: '00',
      secoend: '00'
    }
  }

  return timeObj
}

function add0 (num) {
  return (num < 10) & (num >= 0) ? '0' + num : num
}

//创建随机字符
function makeRandomChar (addLen) {
  let chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']
  let newStr = ''

  // 字符长度不能超过15位
  for (let i = 0; i < addLen; i++) {
    newStr = newStr + chars[Math.floor(Math.random() * chars.length)]
  }
  return newStr
}

/**
 * 用原生 JS 封装一个 Toast 组件
 */
var Toast = {
  // 隐藏的 setTimeOut 引用
  hideTimeOut: null,
  /**
   * 初始化
   */
  init: function () {
    var toastNode = document.createElement('section');
    toastNode.innerHTML = '<i class="iconfont icon-success"></i><i class="iconfont icon-error"></i><span class="text">111</span>';
    toastNode.id = 'toastWaka'; // 设置id，一个页面有且仅有一个Toast
    toastNode.setAttribute('class', 'toast');   // 设置类名
    toastNode.style.display = 'none';   // 设置隐藏
    document.body.appendChild(toastNode);
  },
  /**
   * 显示Toast
   * @param text 文本内容
   * @param type 类型 success error
   * @param duration 持续时间
   */
  show: function (text, type, duration) {
    // 确保上一次的 TimeOut 已被清空
    if (this.hideTimeOut) {
      clearTimeout(this.hideTimeOut);
      this.hideTimeOut = null;
      // console.error('上一次的 TimeOut 还未走完!');
      // return;
    }
    if (!text) {
      console.error('text 不能为空!');
      return;
    }
    var domToastWaka = document.getElementById('toastWaka');
    console.log('domToastWaka', domToastWaka);
    if (!domToastWaka) {
      console.error('toastWaka DOM 不存在!');
      return;
    }
    var domIconSuccess = domToastWaka.querySelector('.icon-success');   // 成功图标
    var domIconError = domToastWaka.querySelector('.icon-error');   // 错误图标
    var domToastText = domToastWaka.querySelector('.text');   // 文字
    domToastText.innerHTML = text || '';
    switch (type) {
      case 'success':
        domIconSuccess.style.display = 'inline-block';
        domIconError.style.display = 'none';
        break;
      case 'error':
        domIconSuccess.style.display = 'none';
        domIconError.style.display = 'inline-block';
        break;
      default:
        domIconSuccess.style.display = 'none';
        domIconError.style.display = 'none';
        break;
    }
    domToastWaka.style.display = 'block';
    // 不传的话默认2s
    var that = this;
    this.hideTimeOut = setTimeout(function () {
      domToastWaka.style.display = 'none';
      that.hideTimeOut = null;    // 置 TimeOut 引用为空
    }, duration || 3000);
  },
  /**
   * 隐藏 Toast
   */
  hide: function () {
    // 如果 TimeOut 存在
    if (this.hideTimeOut) {
      // 清空 TimeOut 引用
      clearTimeout(this.hideTimeOut);
      this.hideTimeOut = null;
    }
    var domToastWaka = document.getElementById('toastWaka');
    if (domToastWaka) {
      domToastWaka.style.display = 'none';
      document.body.removeChild(domToastWaka);
    }
  }
};

//时间本地化
function localGMTTime (time) {
  let timeStamp = new Date().getTimezoneOffset() * 60;
  let hour;
  if (Math.abs(timeStamp) / 3600 + time >= 24) {
    hour = Math.floor(Math.abs(timeStamp) / 3600) + time - 24;
  } else {
    hour = Math.floor(Math.abs(timeStamp) / 3600) + time;
  }
  let minute = Math.floor((Math.abs(timeStamp) / 60) % 60);
  let localTime = add0(hour) + ":" + add0(minute);
  return localTime
}

//动态添加vconsole脚本
function addScrpit () {
  if (location.href.indexOf('http://dt.freetelcall.com/') === -1) {
    let scriptNode = document.createElement('script')
    scriptNode.setAttribute("type", "text/javascript");
    let src = 'https://cdn.bootcss.com/vConsole/3.3.0/vconsole.min.js'
    scriptNode.setAttribute("src", src);
    document.body.appendChild(scriptNode)
    setTimeout(() => {
      var vConsole = new VConsole()
    }, 1000)
  }
}