let compatibleList = [
  {
    type: 5402, // native底部bannber广告
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.0'
      },
      {
        pid: 0,
        deviceType: 'and',
        verBoundary: '4.12.4'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.0'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.13.0'
      }
    ]
  },
  {
    type: 5601, // 客户端webview 返回事件
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.0'
      },
      {
        pid: 0,
        deviceType: 'and',
        verBoundary: '4.13.3'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.14.2'
      }
    ]
  },
  {
    type: 5403, // andorid是否有缓存
    version: [
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.13.1'
      }
    ]
  },
  {
    type: 1301, // 跳转签到页面
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.15.0'
      }
    ]
  },
  {
    type: 1302, // 跳转有奖邀请页面
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.15.0'
      }
    ]
  },
  {
    type: 1303, // 跳转Tapjoy界面
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.15.0'
      }
    ]
  },
  {
    type: 100, // 新增bindedEmail 是否绑定邮箱
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.15.0'
      }
    ]
  },
  {
    type: 101, // 新增webViewWidth，webViewHeight 当前webview的宽高，单位px
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 0,
        deviceType: 'and',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.14.4'
      }
    ]
  },
  {
    type: 102, // 新增tapjoyStatus
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.15.0'
      }
    ]
  },
  {
    type: 5404, // 查询是否有插入屏广告资源
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 0,
        deviceType: 'and',
        verBoundary: '4.14.4'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.14.4'
      }
    ]
  },
  {
    type: 5405, // 通知客户端显示广告
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 0,
        deviceType: 'and',
        verBoundary: '4.14.4'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.14.4'
      }
    ]
  },
  {
    type: 5406, // 通知客户端隐藏广告
    version: [
      {
        pid: 0,
        deviceType: 'ios',
        verBoundary: '4.9.1'
      },
      {
        pid: 3,
        deviceType: 'ios',
        verBoundary: '3.6.1'
      },
      {
        pid: 0,
        deviceType: 'and',
        verBoundary: '4.14.4'
      },
      {
        pid: 3,
        deviceType: 'and',
        verBoundary: '4.14.4'
      }
    ]
  }
]


/*
 *@method 版本大小比较
 *@param {
    curV--当前版本,
    reqV--待判断版本
 }
 *@return{
     true -- curv>reqV
     false -- cur<==reqV
 }
 */
function judgeVersion (curV, reqV) {
  var arr1 = curV.toString().split('.')
  var arr2 = reqV.toString().split('.')
  var minL = Math.min(arr1.length, arr2.length)
  var pos = 0
  var diff = 0
  var flag = false
  while (pos < minL) {
    diff = parseInt(arr1[pos]) - parseInt(arr2[pos])
    if (diff == 0) {
      pos++
      continue
    } else if (diff > 0) {
      flag = true
      break
    } else {
      flag = false
      break
    }
  }
  return flag
}

/*
 *@method 原生广告的显示与隐藏
 *@param {
   type:5402,原生广告,
   isShow:显示与隐藏广告
 }
 *@return{}
 */

function adNativeShow (type, isShow, campaignId, adId, pid, version) {
  return new Promise((resolve, reject) => {
    if (handleCompatible(type, pid, version)) {
      let params = {
        content: isShow,
        campaignId,
        adId
      }
      callHandler(type, params, (res) => {
        resolve(res)
      })
      // Vue.prototype.$jsBridge.callHandler(type, params, res => {
      //   resolve(res)
      // })
    }
  })
}

/*
 *@method andorid与ios判断
 *@param {}
 *@return{
     true -- ios
     false -- andorid
 }
 */
function deviceIsAndIos () {
  if (navigator.userAgent.match(/(iPhone|iPod|iPad);?/i)) {
    return true
  } else {
    return false
  }
}

//设备类型
function deviceIsAndIos () {
  if (navigator.userAgent.match(/(iPhone|iPod|iPad);?/i)) {
    return true
  } else {
    return false
  }
}

//处理版本兼容
function handleCompatible (type, pid, version) {
  let deviceType = deviceIsAndIos() ? 'ios' : 'and'
  // 找到对应type
  let compatibleByTypeList = compatibleList.filter((item) => {
    return item['type'] === type
  })
  // 找到对应version
  let compatibleEndedList = compatibleByTypeList[0]['version'].filter(
    (item) => {
      return item['pid'] === pid && item['deviceType'] === deviceType
    }
  )
  let verBoundary = compatibleEndedList[0]['verBoundary']
  if (judgeVersion(verBoundary, version)) {
    return false
  } else {
    return true
  }
}
// 底部5405native广告
function bannerAdHandle (pid, version, campaignId, adId, modalContentHeight) {
  return Promise.all([
    bannerAdShowHide(5404, {}, pid, version),
    getClientConfig(101, {}, pid, version),
  ])
    .then((res) => {
      console.log('res===', res)
      const clientInfo = res[1]
      res = res[0]

      console.log('底部弹窗banner广告执行了', res.data.hasAdCache === 1)

      // 有广告资源
      if (res.data.hasAdCache === 1) {
        // 广告的webview高度,8表示广告离底部的距离
        let adsY =
          clientInfo.data.webViewHeight -
          res.data.height -
          (16 * window.innerHeight) / clientInfo.data.webViewHeight
        // 广告转化h5的px,dpr为1
        const adsYTranPx =
          (adsY * window.innerHeight) / clientInfo.data.webViewHeight

        let params = {
          content: 1,
          campaignId,
          adId,
          extendData: {
            x: 0,
            y: adsY,
          },
        }
        console.log(
          'adsYTranPx执行44444444444',
          adsYTranPx,
          res.data.height < clientInfo.data.webViewHeight / 2
        )
        let y = modalContentHeight * clientInfo.data.webViewHeight / window.innerHeight  // H5转原生高度
        // 大屏幕显示广告
        console.log(
          modalContentHeight,
          y,
          screen.availHeight,
          window.innerHeight,
          clientInfo.data.webViewHeight,
          'adsYTranPx执行44444444444',
          adsYTranPx,
          res.data.height,
          res.data.height < clientInfo.data.webViewHeight / 2
        )
        if (clientInfo.data.webViewHeight - res.data.height - y - 100 > 0 ) {
          bannerAdShowHide(5405, params, pid, version)
         
          // 弹窗离顶部的距离，8表示弹窗和广告之间的距离,安卓机型太多，不好适配
          let modalWrapHeight
          if (navigator.userAgent.match(/(iPhone|iPod|iPad);?/i)) {
            modalWrapHeight = (adsYTranPx - modalContentHeight) / 2
          } else {
            modalWrapHeight = (adsYTranPx - modalContentHeight) / 2
          }

          console.log('modalWrapHeight$$$$$$$', modalWrapHeight)
          return modalWrapHeight
        } else {
          adNativeShow(5402, 1, campaignId, adId, pid, version)
          return 0
        }
      }
    })
    .catch((e) => {
      console.log('展示广告5404失败')
    })
}

//关闭5405广告
function hide5405Ad (adId, campaignId) {
  let params = {
    content: 0,
    campaignId,
    adId,
  }
  console.log('底部弹窗banner广告关闭', adId, campaignId)
  bannerAdShowHide(5406, params, userInfo.pid, userInfo.version)
  callHandler(5401, {
    campaignId: campaignId,
    adId: adId,
  }, function() {});

}
// 关闭广告
function bannerAdHide (pid, version, campaignId, adId, modalContentHeight) {
  let params = {
    content: 0,
    campaignId,
    adId
  }
  bannerAdShowHide(5406, params, pid, version)
  adNativeShow(5402, 0, campaignId, adId, pid, version)
  callHandler(5401, {
    campaignId: campaignId,
    adId: adId,
  }, function() {});
}

/*
 *@method banner类型的native广告
 *@param {
   type:5404（查询是否有资源），5405（通知客户端显示广告），5406（通知客户端隐藏广告）
 }
 *@return{}
 */

function bannerAdShowHide (type, params, pid, version) {
  console.log(type, params, pid, version)
  return new Promise((resolve, reject) => {
    if (handleCompatible(type, pid, version)) {
      callHandler(type, params, (res) => {
        console.log(res)
        console.log(
          '广告执行',
          type,
          params,
          JSON.parse(decodeURIComponent(res))
        )
        resolve(JSON.parse(decodeURIComponent(res)))
      })
    } else {
      resolve()
    }
  })
}

/*
 *@method 获取 Client 基本 Config 信息
 *@for 客户端交互
 *@param type-101,基本 Client 信息
 */
function getClientConfig (type, params) {
  return new Promise((resolve, reject) => {
    callHandler(type, params, (res) => {
      console.log('callHandler')
      resolve(JSON.parse(decodeURIComponent(res)))
    })
  })
}

/*
 *@method 广告预加载,播放广告
 *@param {
   type-5401,广告预加载
   type-5400,观看广告
   type-5403,andorid有无广告
   campaignId-活动id,server
   adId-广告id,商业化
 }
 *@return{}
 */
function adPreWatch (type, campaignId, adId) {
  return new Promise((resolve, reject) => {
    let params = {
      campaignId,
      adId,
    }

    callHandler(type, params, (res) => {
      if (type === 5403) {
        resolve(decodeURIComponent(res))
      }
      if (type === 5401) {
        console.log(5401222222222222222)
        resolve()
      }
    })
    if (type === 5400) {
      registerHandler((res) => {
        resolve(decodeURIComponent(res))
      })
    }
  })
}

/*
 *@method 客户端webview返回操作
 *@param {
   type-5601,
   isPending-1/等待,0/不等待
 }
 *@return{}
 */

function navBackClicked (type, isPending, pid, version) {
  return new Promise((resolve, reject) => {
    let params = {
      content: JSON.stringify({
        pendingBack: isPending,
      }),
    }

    callHandler(type, params, (res) => { })

    if (type === 5601) {
      if (handleCompatible(type, pid, version)) {
        registerHandler((res) => {
          resolve(decodeURIComponent(res))
        })
      }
    }
  })
}

/*
 *@method 退出webview
 *@param {
   type-5601,
   back:1-退出，只有
 }
 *@return{}
 */

function backWebview (type, pid, version) {
  return new Promise((resolve, reject) => {
    console.log('handleCompatible(type, pid, version)1111111111111111111111', handleCompatible(type, pid, version))
    if (handleCompatible(type, pid, version)) {
      let params = {
        content: JSON.stringify({
          back: 1,
        }),
      }

      callHandler(type, params, (res) => { })
      resolve({ Result: 1 })
    } else {
      resolve({ Result: 0 })
    }
  })
}
