const isAndroid =
  navigator.userAgent.indexOf('Android') > -1 ||
  navigator.userAgent.indexOf('Adr') > -1
const isiOS = navigator.userAgent.match(/(iPad).*OS\s([\d_]+)/) || navigator.userAgent.match(/Mac/) || navigator.userAgent.match(/(iPhone\sOS)\s([\d_]+)/)

//用以获取安卓的本地对象
function setupWebViewJavascriptBridge(callback) {
  if (isAndroid) {
    console.log(
      'setupWebViewJavascriptBridge函数执行',
      window.WebViewJavascriptBridge
    )
    if (window.WebViewJavascriptBridge) {
      callback(WebViewJavascriptBridge)
    } else {
      document.addEventListener(
        'WebViewJavascriptBridgeReady',
        function () {
          callback(WebViewJavascriptBridge)
        },
        false
      )
    }
  }

  //用以获取IOS本地对象
  if (isiOS) {
    if (window.WebViewJavascriptBridge) {
      return callback(WebViewJavascriptBridge)
    }
    if (window.WVJBCallbacks) {
      return window.WVJBCallbacks.push(callback)
    }
    window.WVJBCallbacks = [callback]
    let WVJBIframe = document.createElement('iframe')
    WVJBIframe.style.display = 'none'
    WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__'
    document.documentElement.appendChild(WVJBIframe)
    setTimeout(function () {
      document.documentElement.removeChild(WVJBIframe)
    }, 0)
  }
}

//安卓端，接收数据时，需要先进行初始化。有时获取不到WebViewJavascriptBridge对象
;(function (bridge) {
  if (isAndroid) {
    bridge.init(function (message, responseCallback) {
      const data = {
        'Javascript Responds': 'Wee!',
      }
      responseCallback(data)
    })
  }
})()

document.addEventListener('WebViewJavascriptBridgeReady', (event) => {
  console.log('WebViewJavascriptBridgeReady')
})

// 给APP发送数据
function callHandler(type, params, callback) {
  if (type === 5401) {
    console.log('预加载广告', params.adId)
  }
  setupWebViewJavascriptBridge(function (bridge) {
    bridge.callHandler(
      'AppBridgeSuperFn',
      encodeURIComponent(
        JSON.stringify({
          type,
          params,
        })
      ),
      callback
    )
  })
}

// 接收APP端的数据
function registerHandler(callback) {
  setupWebViewJavascriptBridge(function (bridge) {
    bridge.registerHandler('JSBridgeSuperFn', callback)
  })
}
